-- empire lib for  structs V2 converted to use rds libs for the claro cairo wrap project ---
-- this version is unreleased alpha copy and all errors introduced are probably mine --
--include std/core.em

include std-sequence.e
-- STRING.E --
global function lower_(object x)
-- convert atom or sequence to lower case
    return x + (('A' <= x and x <= 'Z') * ' ')
end function

global function upper_(object x)
-- convert atom or sequence to upper case
    return x - (('a' <= x and x <= 'z') * ' ')
end function

-----------------------------------------------------------------------------
-- BITWISE MANIPULATORS --

------------------------------------------------
global function lo_byte( integer i1 )
------------------------------------------------
-- syntax: i2 = lo_byte( i1 )
-- description:
--    returns the low byte i2, from the word(2 bytes) i1

    -- return low byte
    return and_bits( i1, #FF )
end function

------------------------------------------------
global function hi_byte( integer i1 )
------------------------------------------------
-- syntax: i2 = hi_byte( i1 )
-- description:
--    returns the high byte i2, from the word(2 bytes) i1

    -- return high byte
    return floor( and_bits(i1,#FF00) / #100 )
end function

------------------------------------------------
global function lo_word( atom a )
------------------------------------------------
-- syntax: i = lo_word( a )
-- description:
--    returns the low word(2 bytes) i, from the long(4 bytes) a

    -- return low word
    return and_bits( a, #FFFF )
end function

------------------------------------------------
global function hi_word( atom a )
------------------------------------------------
-- syntax: i =  hi_word( a )
-- description:
--    returns the high word(2 bytes) i, from the long(4 bytes) a

    -- return high word
    return and_bits(floor( a / #10000 ), #FFFF)
end function

------------------------------------------------
global function make_word( integer lo, integer hi)
------------------------------------------------
-- syntax: i = make_word( lo, hi )
-- description:
--    make 2 bytes (8bit) into a word (16bit)

   -- mask values ( copied from Derek Parnell's tk_math.e )
   lo  = and_bits( lo,  #FF )
   hi = and_bits( hi, #FF )
   
   return hi*#100 + lo
end function

------------------------------------------------
global function lo_dword( atom a )
------------------------------------------------
-- syntax: i = lo_dword( a )
-- description:
--    returns the low dword(4 bytes) i, from the double(8 bytes) a

    -- return low dword
    return remainder(a,#100000000)
end function

------------------------------------------------
global function hi_dword( atom a )
------------------------------------------------
-- syntax: i =  hi_dword( a )
-- description:
--    returns the high dword(4 bytes) i, from the double(8 bytes) a

    -- return high dword
    return floor(a/#100000000)
end function

------------------------------------------------
global function make_dword( integer lo, integer hi)
------------------------------------------------
-- syntax: a = make_long( lo, hi )
-- description:
--    make 2 words (16bit) into a long (32bit)

   -- mask values ( copied from Derek Parnell's tk_math.e )
   lo  = and_bits( lo,  #FFFF )
   hi = and_bits( hi, #FFFF )

   return hi*#10000 + lo
end function

global function make_long( integer lo, integer hi)
  return make_dword(lo,hi)
end function
------------------------------------------------

------------------------------------------------
global function make_qword( atom lo, atom hi)
------------------------------------------------
  lo  = and_bits( lo, #FFFFFFFF )
  hi = and_bits( hi, #FFFFFFFF )
  return hi*#100000000 + lo
end function
------------------------------------------------



---------------------------------------------------------------------------------
--~ global function int_to_bits(atom x, integer nbits)
--~ --    Returns the low-order nbits bits of x as a sequence of 1's and 0's. 
--~ --    Note that the least significant bits come first. You can use Euphoria's
--~ --    and/or/not operators on sequences of bits. You can also subscript, 
--~ --    slice, concatenate etc. to manipulate bits.
 --~ sequence bits
 --~ integer mask
    
  --~ bits = repeat(0, nbits)
  --~ if integer(x) and nbits < 30 then
  	--~ -- faster method
	  --~ mask = 1
	  --~ for i = 1 to nbits do
	    --~ bits[i] = and_bits(x, mask) and 1
	    --~ mask *= 2
	  --~ end for
  --~ else
	  --~ -- slower, but works for large x and large nbits
	  --~ if x < 0 then
	    --~ x += power(2, nbits) -- for 2's complement bit pattern
	  --~ end if
	  --~ for i = 1 to nbits do
	    --~ bits[i] = remainder(x, 2) 
	    --~ x = floor(x/2)
	  --~ end for
  --~ end if
  --~ return bits
--~ end function


--~ global function bits_to_int(sequence bits)
--~ -- get the (positive) value of a sequence of "bits"
 --~ atom value, p
  --~ value = 0
  --~ p = 1
  --~ for i = 1 to length(bits) do
  	--~ if bits[i] then
	    --~ value += p
	  --~ end if
	  --~ p += p
  --~ end for
  --~ return value
--~ end function

global function bits_to_signed(sequence bits)
-- get the (signed) value of a sequence of "bits"
 atom val, p
 integer sign
  if length(bits) < 2 then return 0 end if
  val = 0
  p = 1
  if bits[1] then sign = -1 else sign = 1 end if
  for i = 2 to length(bits) do
  	if bits[i] then
	    val += p
	  end if
	  p += p
  end for
  return sign * val
end function
---------------------------------------------------------------------------------


--~ ---------------------------------------------------------------------------------
--~ constant mem = machine_func(M_ALLOC,4)

--~ global function int_to_bytes(atom x)
--~ -- returns value of x as a sequence of 4 bytes 
--~ -- that you can poke into memory 
--~ --      {bits 0-7,  (least significant)
--~ --       bits 8-15,
--~ --       bits 16-23,
--~ --       bits 24-31} (most significant)
--~ -- This is the order of bytes in memory on 386+ machines.
  --~ poke4(mem,x)
  --~ return peek({mem,4})
--~ end function


--~ global function bytes_to_int(sequence s)
--~ -- converts 4-byte peek() sequence into an integer value
  --~ poke(mem,s[1..4])
  --~ return peek4u(mem)
--~ end function

--~ global function bytes_to_signed(sequence s)
--~ -- converts 4-byte peek() sequence into a signed integer value
  --~ poke(mem,s[1..4])
  --~ return peek4s(mem)
--~ end function
--~ ---------------------------------------------------------------------------------


--~ ---------------------------------------------------------------------------------
--~ type sequence_8(sequence s)
--~ -- an 8-element sequence
  --~ return length(s) = 8
--~ end type

--~ type sequence_4(sequence s)
--~ -- a 4-element sequence
  --~ return length(s) = 4
--~ end type

--~ global function atom_to_float64(atom a)
--~ -- Convert an atom to a sequence of 8 bytes in IEEE 64-bit format
    --~ return machine_func(M_A_TO_F64, a)
--~ end function

--~ global function atom_to_float32(atom a)
--~ -- Convert an atom to a sequence of 4 bytes in IEEE 32-bit format
    --~ return machine_func(M_A_TO_F32, a)
--~ end function

--~ global function float64_to_atom(sequence_8 ieee64)
--~ -- Convert a sequence of 8 bytes in IEEE 64-bit format to an atom
    --~ return machine_func(M_F64_TO_A, ieee64)
--~ end function

--~ global function float32_to_atom(sequence_4 ieee32)
--~ -- Convert a sequence of 4 bytes in IEEE 32-bit format to an atom
    --~ return machine_func(M_F32_TO_A, ieee32)
--~ end function
--~ ---------------------------------------------------------------------------------

global function nbits(atom a)
  a = not_bits(a)
  if a < 0 then a += #100000000 end if
  return a
end function

global function abits(atom a1, atom a2)
  a1 = and_bits(a1,a2)
  if a1 < 0 then a1 += #100000000 end if
  return a1
end function

global function obits(atom a1, atom a2)
  a1 = or_bits(a1,a2)
  if a1 < 0 then a1 += #100000000 end if
  return a1
end function

global function xbits(atom a1, atom a2)
  a1 = xor_bits(a1,a2)
  if a1 < 0 then a1 += #100000000 end if
  return a1
end function

---------------------------------------------------------------------------------


------------------------------------------------
global function or_all(sequence s)
------------------------------------------------
-- syntax: a = or_all( s )
-- description:
--    combine a sequence of atoms using or_bits(), and return the value
 atom a
   a = s[1]
   for i = 2 to length(s) do
      a = obits(a,s[i])
   end for
   return a
end function
------------------------------------------------

------------------------------------------------
global function xor_all(sequence s)
------------------------------------------------
-- syntax: a = xor_all( s )
-- description:
--    combine a sequence of atoms using xor_bits(), and return the value
 atom a
   a = s[1]
   for i = 2 to length(s) do
      a = xbits(a,s[i])
   end for
   return a
end function
------------------------------------------------

------------------------------------------------
global function and_all(sequence s)
------------------------------------------------
-- syntax: a = and_all( s )
-- description:
--    combine a sequence of atoms using and_bits(), and return the value
 atom a
   a = s[1]
   for i = 2 to length(s) do
      a = abits(a,s[i])
   end for
   return a
end function
------------------------------------------------

global function OR(sequence s) return or_all(s) end function
global function XOR(sequence s) return xor_all(s) end function
global function AND(sequence s) return and_all(s) end function
global function NOT(atom x) return nbits(x) end function

---------------------------------------------------------------------------------

global function binhex(object x)
  return x + '0' + ((x >= #A) * ('A' - '9' - 1))
end function

global function hexbin(object x)
  x = upper_(x)
  return x - '0' - ((x >= 'A') * ('A' - '9' - 1))
end function

-- convert an array of bytes to a hex string, using big endian or little endian
-- eg {255,255,255,255} converts to "FFFF"
-- big endian is TRUE
-- eg bytes_to_hex({31},FALSE) = "1F"
--    bytes_to_hex({31},TRUE)  = "F1"
global function bytes_to_hex(integer endian, sequence s)
  if not length(s) then return "" end if
  endian = (endian != FALSE)
  
  -- split into nibbles
  s = {floor(s/16), mod(s,16)}
  s = merge({s[1+endian],s[2-endian]})

  return binhex(s)
end function

global function hex_to_bytes(integer endian, sequence s)
 sequence s1,s2
 integer len
  len = length(s)
  len = remainder(length(s),2)
  if len then
    if endian then s &= '0' else s = '0' & s end if
  end if

  s1 = hexbin(s) -- convert hex string to values

  -- combine nibbles
  s2 = repeat(0,length(s1)/2)
  for i = 1 to length(s2) do
    s2[i] = #10 * s1[i*2+endian-1] + s1[i*2-endian]
  end for
  return s2
end function

---------------------------------------------------------------------------------
